import java.io.*;
import java.util.*;

class Polozka{
	Polozka dalsi;
    int klic;  
    Polozka(int klic){
  	  	this.klic=klic;
    }
}

class Fronta{
	Polozka zacatek, konec;

	public boolean jePrazdna(){
		return (this.zacatek==null);
	}
	
	public void pridat(int klic){
		Polozka novy = this.konec;
		this.konec = new Polozka(klic);
		if(this.zacatek==null)
			this.zacatek=this.konec;
		else novy.dalsi=this.konec;
	}
	
	public int vyber(){
		int v=zacatek.klic;
		zacatek=zacatek.dalsi;
		return v;
	}
}

class Vrchol {
	String mesto;
	int cas;
	Soused soused;
	
	Vrchol(String mesto){
		this.mesto = mesto;
		this.cas = Integer.MAX_VALUE;
		this.soused = null;
	}
}

class Soused {
	int odjezd;
	int trvani;
	int index;
	Soused dalsi;
	
	Soused(int index, int odjezd, int trvani, Soused dalsi){
		this.index = index;
		this.odjezd = odjezd;
		this.trvani = trvani;
		this.dalsi = dalsi;
	} 
}


class Graf {
	Vrchol[] poleVrcholu;
	
	Graf(int n) {
		this.poleVrcholu=new Vrchol[n];
	}
	void pridej(String mesto_z, String mesto_kam, int odjezd, int trvani) {
		int i = 0;
		
		odjezd = (odjezd + 6) % 24;
		
		if (odjezd > 12 || odjezd + trvani > 12 || trvani > 12) return;
				
		for(i=0;i<this.poleVrcholu.length;i++) {
			if (this.poleVrcholu[i]==null) {
				this.poleVrcholu[i]=new Vrchol(mesto_z);
				break;
			} else if (this.poleVrcholu[i].mesto.equals(mesto_z)) {
				break;
			}
		}
		
		this.poleVrcholu[i].soused = new Soused(this.vratIDMesta(mesto_kam, true),odjezd,trvani,this.poleVrcholu[i].soused);
	}
   
   	int vratIDMesta(String mesto, boolean vytvorit) {
   		for(int i=0;i<this.poleVrcholu.length;i++) {
   			if (vytvorit && this.poleVrcholu[i]==null) {
   				this.poleVrcholu[i] = new Vrchol(mesto);
   				return i;
   			} else if (this.poleVrcholu[i].mesto.equals(mesto)) return i;
   		}
   		return -1;
   	}
   
    int pocetLitru(String mesto_z, String mesto_kam){
		if (this.poleVrcholu[0]==null) return Integer.MAX_VALUE;

    	Fronta f = new Fronta();
    	
    	Soused x;
    	int i;
    	int cas;
    	
    	i = this.vratIDMesta(mesto_z,false);
    	int m_kam = this.vratIDMesta(mesto_kam,false);
    	
    	this.poleVrcholu[i].cas = 0;

        f.pridat(i);
        while(!f.jePrazdna()){
           	int v = f.vyber();
        	x = poleVrcholu[v].soused;
        	while(x != null){
        		cas = poleVrcholu[v].cas + Math.abs((24 - (poleVrcholu[v].cas % 24 - x.odjezd)) % 24) + x.trvani;

        		if(poleVrcholu[x.index].cas > cas){
        			poleVrcholu[x.index].cas = cas;
        		  	f.pridat(x.index);
        	    }
        	    x=x.dalsi;
        	}        	
		}
		if (poleVrcholu[m_kam].cas == Integer.MAX_VALUE) return Integer.MAX_VALUE;
		return poleVrcholu[m_kam].cas / 24 + ((poleVrcholu[m_kam].cas % 24 > 12) ? 1 : 0);
	}	
}

class Main {
	static String ctiSlovo() {
		StringBuffer R = new StringBuffer();
		int C;
		try {
			while (true) {
				C = System.in.read();
				//if (C==13) C = System.in.read();
				if (C==32 || C==10) break;
				R.append((char)C);
			}
		} catch (Exception e) {
			e.printStackTrace();
			R = new StringBuffer();
		}
		return R.toString();
	}

	public static void main(String[] args) {
		Graf vladimir;

		String tmp1;
		String tmp2;
		String tmp3;
		String tmp4;
		
		int pocetVlaku;
		int pocetLitru;

		tmp1 = ctiSlovo();
		int pocetVypoctu = Integer.parseInt(tmp1);
		
		for (int i=1; i<=pocetVypoctu;i++) {
			vladimir = new Graf(100);
			
			tmp1 = ctiSlovo();
			pocetVlaku = Integer.parseInt(tmp1);
			for(int y=1; y<=pocetVlaku;y++) {
				
				tmp1 = ctiSlovo();
				tmp2 = ctiSlovo();
				tmp3 = ctiSlovo();
				tmp4 = ctiSlovo();
				
				vladimir.pridej(tmp1, tmp2, Integer.parseInt(tmp3), Integer.parseInt(tmp4));
			}

			tmp1 = ctiSlovo();
			tmp2 = ctiSlovo();

			pocetLitru = vladimir.pocetLitru(tmp1, tmp2);
			
			System.out.print("Test Case "+i+".\n");
			if (pocetLitru == Integer.MAX_VALUE) {
				System.out.print("There is no route Vladimir can take.\n");
			} else {
				System.out.print("Vladimir needs "+pocetLitru+" litre(s) of blood.\n");
			}
		}
	}
}